@echo off

REM: Path setup

SET src=%cd%
cd ..
if not exist "build\" mkdir build
cd build


REM: ### THE ARRANGEMENT OF THIS BUILD ###
REM:  The "base layer" must be built and shared by all dynamic components.
REM:  In this example the the base layer is linked via load-time linking with the other modules.
REM:  The "plugin" is loaded at run-time.



REM: Build the base layer as a .dll (also produces load-time linking data in win32_base.lib)
cl /nologo /LD %src%\win32_base.c


REM: Build the executable; provide the base layer's load-time linking data via win32_base.lib
cl /nologo %src%\win32_main.c win32_base.lib


REM: Build the plugin as a .dll; provide the base layer's load-time linking data via win32_base.lib
cl /nologo /LD %src%\win32_plugin.c win32_base.lib

